#version 330 core
in vec3 position;
in vec3 normal;
in vec2 tex_coords;

uniform mat4 view;
uniform mat4 matrix;
uniform mat4 projection;

out vec3 FragPos;
out vec3 Normal;
out vec2 v_tex_coords;

void main() {
     v_tex_coords = tex_coords;
     gl_Position = projection * view * matrix * vec4(position, 1.0);
     FragPos = vec3(matrix * vec4(position, 1.0));
     Normal = mat3(transpose(inverse(matrix))) * normal;
}